/*
 * Eprom Programmer
 *
 * Copyright 1996-2007 netFluid Technology Ltd
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1 $  $Date: 2007/02/15 16:37:50 $
 * 
 * --------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>

#include "ceprog.h"
#include "device.h"
#include "devtypes.h"

/* ------------------------------------------------------------------------- */

void
display_device( int id, Device *dev )
{
        printf( "%2d: %-15s %-24.24s %3dK  %2.2f %3.2f %4d    %7ldus\n", 
                id,
                dev->device,
                dev->manufacturer,
                dev->size / 1024,
                dev->vpp,
                dev->vcc,
                dev->pins,
                dev->pulse_us );
}

/* ------------------------------------------------------------------------- */

void
display_devices()
{
    int i = 0;

    printf( "Supported devices:\n\n" );

    printf( "%2s  %-15s %-24s %4s  %5s %4s %4s %12s\n", "ID",
    "Device", "Manufacturer", "Size", "VPP", "VCC", "Pins", "Pulse Width" );

    for( i = 0; knownDevices[i].device != NULL; i++ ) {
        display_device( i+1, &knownDevices[i] );
    }

    printf( "\n\n" );
}

/* ------------------------------------------------------------------------- */

Device *
get_device_parameters( int id )
{
    int i = 0;

    for( i = 0; knownDevices[i].device != NULL; i++ ) {
        if( i + 1 == id ) return &knownDevices[i];
    }

    return NULL;
}

/* ------------------------------------------------------------------------- */
/* end */
